        SUBROUTINE FSYSTEM(STRING)
        CHARACTER*(*) STRING
        INTEGER EXDOS,RETCOD
        RETCOD=EXDOS(STRING)
        RETURN
        END
        LOGICAL FUNCTION SYSTEMQQ(STRING)
        CHARACTER*(*) STRING
        INTEGER EXDOS,RETCOD
        RETCOD=EXDOS(STRING)
        SYSTEMQQ=.FALSE.
        IF(RETCOD.GE.0)SYSTEMQQ=.TRUE.
        RETURN
        END
        INTEGER FUNCTION SETEXITQQ(X)
        SETEXITQQ=0
        RETURN
        END
        SUBROUTINE SLEEP(N)
        READ(*,*)ITEST
        RETURN
        END
        FUNCTION TIME()
        INTEGER*2 IHR,IMIN,ISEC,I100TH
        CALL GETTIM(IHR,IMIN,ISEC,I100TH)
        TIME=2E8+3600*IHR+60*IMIN+ISEC
        RETURN
        END
        FUNCTION DELFILESQQ(NATEMP)
        CHARACTER*128 NATEMP
        DELFILE=0
        RETURN
        END

        SUBROUTINE GETTIM( IHRS, IMINS, ISECS, IHSECS )
*$noextensions
        integer*2 ihrs,imins,isecs,ihsecs
*
* Define registers: These correspond to the element of an
* array which is to contain the values of the registers.
*
        integer*2 AX,BX,CX,DX,BP,DI,SI,ES,DS,FLAGS
        parameter (AX=1,BX=2,CX=3,DX=4,BP=5,DI=6,SI=7)
        parameter (ES=8,DS=9,FLAGS=10)
        integer NUM$REGS
        parameter (NUM$REGS=10)
*
* Define DOS functions.
*
        integer*2 GETTIME,DOSCALL
        parameter (DOSCALL=33,GETTIME=44)
*
* Define array to contain registers.
*
        integer*2 regs(NUM$REGS)
        integer*1 hrs$min(2),sec$tic(2)
        integer*1 hours,mins,secs,tics
        equivalence (regs(CX),hrs$min)
        equivalence (regs(DX),sec$tic)
        equivalence (hours, hrs$min(2))
        equivalence (mins , hrs$min(1))
        equivalence (secs , sec$tic(2))
        equivalence (tics , sec$tic(1))

*
* Set AH to be DOS 'get time' function.
*
        regs(AX) = GETTIME*256
*
* Return the time.
*
        call intr( DOSCALL, regs )
        ihrs   = hours
        imins  = mins
        isecs  = secs
        ihsecs = tics
        end
      INTEGER FUNCTION EXDOS( CMD )

*     Issue a DOS command from within an executing FORTRAN application.
*     Can be used to implement overlays of pre-compiled "EXE" programs.

*     Example: Issue a DOS 'COPY' command
*              RETCOD = EXDOS( 'COPY *.FOR \BACKUP\FORTRAN' )

*     Example: Run two separate parts of an application
*              RETCOD = EXDOS( 'PART1' )
*              RETCOD = EXDOS( 'PART2' )

*     Requirements: This program uses the integer-valued FORK and DOSENV
*               functions located in WATFOR.LIB.

      character*(*) cmd
      integer fork, dosenv, com_len
      character comspec*80, cmdlin*128
      com_len = dosenv( 'COMSPEC', comspec )
      if( com_len .eq. 0 )then
          comspec = 'command.com'
          com_len = 11
      endif
      comspec(com_len+1:com_len+1) = char(0)
      cmdlin(1:1) = char( 3 + len( cmd ) )
      cmdlin(2:4) = '/c '
      cmdlin(5:) = cmd
      exdos = fork( comspec, cmdlin )
      end
      FUNCTION NARGS()
      INTEGER PARM
      CHARACTER*128 CMDLIN
      NLEN=PARM(CMDLIN)
      NARGS=1
      IF(NLEN.EQ.0)RETURN
      IF(NLEN.EQ.128)RETURN
      NARGS=NARGS+1
      NTEST=1
      DO J=1,NLEN
        IF(CMDLIN(J:J).EQ.' ')THEN
          IF(NTEST.EQ.1)NARGS=NARGS+1
          NTEST=0
        ELSE
          NTEST=1
        ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE GETARG(NTEMP,ARGGG,NSTATUS)
      INTEGER*2 NTEMP,NSTATUS,NARGS,NLBL(64),NFBL(64)
      CHARACTER * (*) ARGGG
      INTEGER PARM
      CHARACTER*128 CMDLIN
      NLEN=PARM(CMDLIN)
      IF(NLEN-1.LT.NTEMP)THEN
        ARGGG=' '
        NSTATUS=1
        RETURN
      ENDIF
      NTEST=1
      IBLC=0
      DO J=1,NLEN
        IF(CMDLIN(J:J).EQ.' ')THEN
          IF(NTEST.EQ.1)THEN
            IBLC=IBLC+1
            NFBL(IBLC)=J
            NLBL(IBLC)=J
            NTEST=0
          ELSE
            NLBL(IBLC)=J
          ENDIF
        ELSE
          NTEST=1
        ENDIF
      ENDDO
      IF(NTEMP.EQ.1)THEN
        NBEG=1
      ELSEIF(NTEMP-1.LE.IBLC)THEN
        NBEG=NLBL(NTEMP-1)+1
      ELSE
        STOP    'error in getarg'
      ENDIF
      IF(NTEMP.GT.IBLC)THEN
        NEND=NLEN
      ELSE
        NEND=NFBL(NTEMP)-1
      ENDIF
      IF(NEND.GE.NBEG)THEN
        ARGGG=CMDLIN(NBEG:NEND)
        NSTATUS=NEND-NBEG+1
      ELSE
        ARGGG=' '
        NSTATUS=1
      ENDIF
      RETURN
      END

      SUBROUTINE SCOUT(ID,F,NOUT)
      REAL*8    F(NOUT)
      NB=1
10      NE=MIN(15+NB,NOUT)
        WRITE(ID)(F(J),J=NB,NE)
        NB=NB+16
        IF(NB.LE.NOUT)GOTO 10
      RETURN
      END

      SUBROUTINE SCIN(ID,F,NIN)
      REAL*8    F(NIN)
      NB=1
10      NE=MIN(15+NB,NIN)
        READ(ID,END=30,ERR=30)(F(J),J=NB,NE)
        NB=NB+16
        IF(NB.LE.NIN)GOTO 10
      RETURN
30    PRINT*,' TOO FEW VALUES IN THE FILE NB,NE',NB,NE
      STOP 'STOP IN SCIN'
      END

